Bug 962496 - kernel: powerpc: can't enable MSIs for AMD FirePro 2270 adapter
kernel: powerpc: can't enable MSIs for AMD FirePro 2270 adapter
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
19
powerpc Linux
unspecified Severity high
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-13 12:47 EDT by Kleber Sacilotto de Souza
Modified: 2013-06-14 08:54 EDT (History)
9 users (show)

See Also:
Fixed In Version: kernel-3.9.5-301.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-07 00:32:47 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
PATCH: powerpc/pseries: Force 32 bit MSIs for devices that require it (e61133dda480062d221f09e4fc18f66763f8ecd0) (2.92 KB, patch)
2013-05-13 12:47 EDT, Kleber Sacilotto de Souza
no flags Details | Diff

  None (edit)
Description Kleber Sacilotto de Souza 2013-05-13 12:47:27 EDT
Created attachment 747296 [details]
PATCH: powerpc/pseries: Force 32 bit MSIs for devices that require it (e61133dda480062d221f09e4fc18f66763f8ecd0)

Description of problem:
The AMD FirePro 2270 graphics adapter reports to the OS that it supports 64-bit MSIs, however, it doesn't actually work if the platform really uses the whole 64 bits for addressing. 

A change has been added to the PAPR document to allow the OS to force the use of 32-bit MSI in such cases even if the PCI capabilities of the adapter indicate otherwise.

A PCI quirk has been added to the ppc64/pseries code to enable the usage of this adapter on ppc64/pseries systems.

These changes have been introduced by commit e61133dda480062d221f09e4fc18f66763f8ecd0.

Version-Release number of selected component (if applicable):
Fedora 19.

How reproducible:
Everytime.

Steps to Reproduce:
1. Load the radeon adapter on a ppc64/pseries system with an AMD FirePro 2270 adapter
  
Actual results:
Driver can't enable MSI on the adapter.

Expected results:
Adapter working with MSI enabled.

Additional info:
Comment 1 Kleber Sacilotto de Souza 2013-05-13 12:49:41 EDT
Can you please consider including this patch for F19?

Thank you.
Comment 2 Josh Boyer 2013-05-13 15:15:42 EDT
Is there a reason this needs to go into F19 as opposed to rawhide, where I would expect it to be brought into the upstream 3.10-rcX tree relatively soon?
Comment 3 Gustavo Luiz Duarte 2013-05-16 14:28:50 EDT
Hi Josh, is the 3.10 kernel going into F19 before the final release? If that is the case it works for us.
Comment 4 Josh Boyer 2013-05-16 14:38:09 EDT
(In reply to comment #3)
> Hi Josh, is the 3.10 kernel going into F19 before the final release? If that
> is the case it works for us.

No, it isn't.

I'm unaware of why F19 is your target when you clearly have numerous items that aren't going to be in the GA kernel for F19.  Perhaps you have some internal process or dates that didn't line up with the Fedora schedule, but 3.9 is going to be the GA kernel for F19.  3.10 will likely be a 0-day update (or very close to it.)

We will, however, be continuing to pull in the latest upstream 3.9.y stable kernels throughout the rest of the F19 schedule.  As I suggested in another bug, you might want to look at getting this patch into 3.9.y as a stable fix.  Then it would be picked up automatically, and everyone using that kernel will benefit, not just Fedora.  We'd also have one less patch to carry.
Comment 5 Josh Boyer 2013-05-31 15:06:28 EDT
Adam pointed this commit out to me again today (along with f1dd153121dcb872ae6cba8d52bec97519eb7d97).  I see that nobody has tried to get it into the stable tree, which is unfortunate.

I'll look at picking these two fixes up for f19 soon.  In the meantime, it is still best if you get them into 3.9.y stable.
Comment 6 Fedora Update System 2013-06-04 08:10:19 EDT
kernel-3.9.4-301.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/kernel-3.9.4-301.fc19
Comment 7 David Aquilina 2013-06-04 11:40:29 EDT
FYI, kernel-3.9.4-301.fc19 fails to build on Power.

 http://ppc.koji.fedoraproject.org/kojifiles/work/tasks/5118/1145118/build.log

Let me know if you want a separate bugzilla for this but I suspect it's related.
Comment 8 Josh Boyer 2013-06-04 12:52:49 EDT
(In reply to David Aquilina from comment #7)
> FYI, kernel-3.9.4-301.fc19 fails to build on Power.
> 
>  http://ppc.koji.fedoraproject.org/kojifiles/work/tasks/5118/1145118/build.
> log
> 
> Let me know if you want a separate bugzilla for this but I suspect it's
> related.

Irritating.  commit e375b561817d9ae098cc4296a729fc88924a0159 introduced that, which is obviously missing in 3.9.y.
Comment 9 Josh Boyer 2013-06-04 13:37:15 EDT
I believe I've fixed this now.  The resulting kernel will need to be heavily tested.  If it doesn't work, then someone will need to provide patches against 3.9.y that do.
Comment 10 Kleber Sacilotto de Souza 2013-06-04 16:55:13 EDT
Josh,

Thank you for picking up the patch and very sorry for the problem it caused. I should have stated that the patch pointed by Adam wouldn't apply cleanly on top of 3.9.

I have tested your changes and it didn't introduce any problem, the radeon driver can initialize the card on systems where the hack is needed.

I will work on get this patch sent to 3.9.y stable tree.

Thank you!
Comment 11 Fedora Update System 2013-06-04 22:34:36 EDT
Package kernel-3.9.4-301.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing kernel-3.9.4-301.fc19'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-10050/kernel-3.9.4-301.fc19
then log in and leave karma (feedback).
Comment 12 Fedora Update System 2013-06-07 00:32:47 EDT
kernel-3.9.4-301.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Fedora Update System 2013-06-11 17:40:18 EDT
kernel-3.9.5-301.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/kernel-3.9.5-301.fc19
Comment 14 Fedora Update System 2013-06-14 00:48:53 EDT
kernel-3.9.5-301.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 15 Kleber Sacilotto de Souza 2013-06-14 08:54:39 EDT
Both patches have made it now to the stable 3.9.y tree and were released on 3.9.6.

powerpc/pseries: Force 32 bit MSIs for devices that require it
http://git.kernel.org/cgit/linux/kernel/git/stable/linux-stable.git/commit/?h=linux-3.9.y&id=12b29dc333b467aba67c6b1c16334e4859f517fb

powerpc/pseries: Make 32-bit MSI quirk work on systems lacking firmware support
http://git.kernel.org/cgit/linux/kernel/git/stable/linux-stable.git/commit/?h=linux-3.9.y&id=63a157c381354ba92145b5636c46475356921a6b

Thank you.

Note You need to log in before you can comment on or make changes to this bug.